﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;

namespace CheckBoxColumnEvents
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            Data = new ObservableCollection<Data>();

            for (int i = 0; i < 10; i++)
            {
                Data.Add(new Data { ID = i, Name = "Item " + i, IsChecked = i % 2 == 0 });
            }

            DataContext = this;
        }

        public ObservableCollection<Data> Data { get; set; }

        private void xamGrid1_CellControlAttached(object sender, Infragistics.Controls.Grids.CellControlAttachedEventArgs e)
        {
            if (e.Cell.Column.Key.Equals("IsChecked"))
            {
                if (GetChildFromType<ContentPresenter>(e.Cell.Control) != null)
                {
                    CheckBox cb = GetChildFromType<ContentPresenter>(e.Cell.Control).Content as CheckBox;

                    if (cb != null)
                    {
                        cb.Checked += new RoutedEventHandler(cb_Checked);
                        cb.Unchecked += new RoutedEventHandler(cb_Unchecked);
                    }
                }
            }
        }

        void cb_Unchecked(object sender, RoutedEventArgs e)
        {
            //do something
        }

        void cb_Checked(object sender, RoutedEventArgs e)
        {
            //do something
        }

        private T GetChildFromType<T>(DependencyObject parent) where T : DependencyObject
        {
            T result = null;

            for (int i = 0; i < VisualTreeHelper.GetChildrenCount(parent); i++)
            {
                if (VisualTreeHelper.GetChild(parent, i) is T)
                {
                    return VisualTreeHelper.GetChild(parent, i) as T;
                }
                else
                {
                    result = GetChildFromType<T>(VisualTreeHelper.GetChild(parent, i));

                    if (result != null)
                    {
                        break;
                    }
                }
            }
            return result;
        }
    }

    public class Data
    {
        public int ID { get; set; }
        public string Name { get; set; }
        public bool IsChecked { get; set; }
    }
}
